#ifndef TALBOT_X_FO_H
#define TALBOT_X_FO_H

#include <math.h>
#include "Types.h"

// Template function object class which calculates the x-coordinate
// of a point at a talbots curve for a given parameter value t
// Parameters:
//    NumType_    the number type of the points coordinates
template <class NumType_> 
class Talbots_curve_x_FO {

public:
    typedef CGAL::Cartesian<NumType_> REP;
    typedef CGAL::Point_2<REP> Point;           
    
    Talbots_curve_x_FO(NumType_ a = 10.0, NumType_ f = 1.0) : a_(a), f_(f) {}    

    NumType_ operator() (NumType_ t) const {
	assert(a_!=0.0);
	return (power(a_,2) + power(f_,2)*power(sin(t),2))*cos(t)/a_;
    }

private:    
    NumType_ a_;
    NumType_ f_;
};
#endif //TALBOT_X_FO_H
