#include "draw_demo.h"

num_type ten_times(num_type t) {
	return 10*t;
}

//Kreis mit Mittelpunkt (0,0) und Radius 1
double kreis_x_func(double t) {
    assert(t>=0 && t<=2*X_k::PI);
    return cos(t);
}

double kreis_y_func(double t) {
    assert(t>=0 && t<=2*X_k::PI);
    return sin(t);
}

int main (int argc, char* argv[]) {
    if(argc<2) {
	cout<<"usage: draw_demo ch"<<endl;
	cout<<"       where ch is one of l (line), c (circle),"<<endl;
	cout<<"       z (cycloid), k (cardioid), a (astroid), "<<endl;
	cout<<"       r (archimed helix), h (hyperbel helix), "<<endl;
	cout<<"       t (tricuspoid), o (Talbot's curve), "<<endl;
	cout<<"       y (hypotrochoid), e (epitrochoid), "<<endl;
	cout<<"       b (Bezier curve), s (B-Spline curve)"<<endl;
	return 5;
    }
    
    int number = (*argv[1]);    
    switch(*argv[1]) {
	case 'l': {
	    cout<<"Gerade mit FO"<<endl;	    
	    int a=2;
	    int b=3;
	    //num_type t(2, 10);
	    /*
	      //Gerade mit Fkt.
	      Gerade_func d(ten_times, ten_times);
	      cout<<"t="<<t<<"... x="<<d.x(t)<<" y="<<d.y(t)<<endl;
	      d.draw();
	    */

	    //Gerade mit FO
	    X x_fo(a, b);
	    Y y_fo(a, b);        
	    Gerade g(&x_fo, &y_fo);	    
	    g.draw();
	    break;
	}
	case 'c': {
	    
	    cout<<"Kreis mit FO"<<endl;
	    //Kreis mit FO
	    X_k::Point center(0.0, 0.0);
	    X_k x_k_fo(center, 1.0); 
	    Y_k y_k_fo(center, 1.0);
	    //falls t in Grad
	    //Kreis kr(&x_k_fo, &y_k_fo, 0.0, 360.0);
	    Kreis kr(&x_k_fo, &y_k_fo, 0.0, 2*X_k::PI);
	    kr.draw();	    
	    
	    /*
	      //Kreis mit Fkt.
	      //dava greshka ako se opitam da napravia Zoom down
	      //X Error: BadAlloc (insufficient resources for operation)
	      //zsh: IOT instruction  param_test
	      Kreis_func circle(cos, sin, 0.0, 2*X_k::PI);
	      circle.draw();   
	    */
	    break;
	}
	case 'z': {
	    cout<<"Zykloide (a>r) mit FO"<<endl;
	    //Zykloide mit FO
	    X_z::Point c(10.0, 10.0);
	    X_z x_z_fo(c, 1.0, 1.7);
	    Y_z y_z_fo(c, 1.0, 1.7);	    
	    Zykloide gem_zykl(&x_z_fo, &y_z_fo, 0.0, 4*X_z::PI);
	    gem_zykl.draw();    
	    break;
	}
	case 'k': {
	    cout<<"Kardioide"<<endl;
	    //Epizykloide (a=r) mit FO
	    X_e::Point c(0.0, 0.0);
	    //Kardioide ist eine Epizikloide mit R=r
	    X_e x_e_fo(c, 1.0, 1.0, 1.0);
	    Y_e y_e_fo(c, 1.0, 1.0, 1.0);    	    
	    Epizykloide kardioide(&x_e_fo, &y_e_fo, 0.0, 2*X_e::PI);
	    kardioide.draw();
	    break;
	}
	case 'a': {
	    cout<<"Astroide"<<endl;
	    //Hypozikloide (a=r) mit FO
	    X_h::Point c(10.0, 10.0);
	    //Asteroide ist eine Hypozykloide mit R=4r
	    X_h x_h_fo(c, 1.0, 4.0, 1.0);
	    Y_h y_h_fo(c, 1.0, 4.0, 1.0);    
	    Hypozykloide astroide(&x_h_fo, &y_h_fo, 0.0, 2*X_h::PI);
	    astroide.draw();       
	    break;
	}
	case 'r': {
	    cout<<"Archimedische Spirale"<<endl;
	    //Archimedische Spirale	    
	    X_ah x_ah_fo;
	    Y_ah y_ah_fo;    
	    Arch_helix archimed(&x_ah_fo, &y_ah_fo, 0.0, 6*X_ah::PI);
	    archimed.draw();       
	    break;
	}
	case 'h': {
	    cout<<"Hyperbolische Spirale"<<endl;
	    //Hyperbolische Spirale	    
	    X_hh::Point c(0.0, 0.0);
	    X_hh x_hh_fo(c, 0.5);
	    Y_hh y_hh_fo(c, 0.5);    
	    Hyperbel_helix helix(&x_hh_fo, &y_hh_fo, 0.01, X_hh::PI);
	    helix.draw();       
	    break;
	}
	case 'w': {
	    cout<<"Witch of Agnesi"<<endl;
	   
	    X_w x_w_fo(10.0);
	    Y_w y_w_fo(10.0);    
	    Witch a_witch(&x_w_fo, &y_w_fo, -5.0, 5.0);
	    a_witch.draw();       
	    break;
	}
	case 'f': {
	    cout<<"Folium of Descartes"<<endl;
	   
	    X_f x_f_fo(10.0);
	    Y_f y_f_fo(10.0);    
	    Folium folium_of_desc(&x_f_fo, &y_f_fo, -5.0, 5.0);
	    folium_of_desc.draw();       
	    break;
	}
	case 't': {
	    cout<<"Tricuspoid"<<endl;
	   
	    X_t x_t_fo(10.0);
	    Y_t y_t_fo(10.0);    
	    Tricuspoid a_tricuspoid(&x_t_fo, &y_t_fo, 0.0, 2*PI);
	    a_tricuspoid.draw();       
	    break;
	}
	case 'o': {
	    cout<<"Talbot's curve"<<endl;
	   
	    X_tc x_tc_fo(1.0, 5.0);
	    Y_tc y_tc_fo(1.0, 5.0, 1.0);    
	    Talbots_curve talbot(&x_tc_fo, &y_tc_fo, 0.0, 2*PI);
	    talbot.draw();       
	    break;
	}
	case 'y': {
	    cout<<"Hypotrochoid"<<endl;
	    //f=0.2 ist auch vernuenftiger Wert (mittlerer arg)
	    X_hy x_hy_fo(2.0, 0.2, 3.0);
	    Y_hy y_hy_fo(2.0, 0.2, 3.0);    
	    Hypotrochoid hypotrochoid(&x_hy_fo, &y_hy_fo, 0.0, 10*PI);
	    hypotrochoid.draw();       
	    break;
	}
	case 'e': {
	    cout<<"Epitrochoid"<<endl;
	   
	    X_et x_et_fo(3.0, 5.0, 2.0);
	    Y_et y_et_fo(3.0, 5.0, 2.0);    
	    Epitrochoid epitrochoid(&x_et_fo, &y_et_fo, 0.0, 10*PI);
	    epitrochoid.draw();       
	    break;
	}
	case 'b': {
	    cout<<"Bezier curve"<<endl;
	    Bezier::Points pts;
	    Bezier:: Point pt_0(-141, 166);	    
	    pts.push_back(pt_0);
	    Bezier::Point pt_1(-130, -80);
	    pts.push_back(pt_1);
	    Bezier::Point pt_2(15, 171);	    
	    pts.push_back(pt_2);
	    Bezier::Point pt_3(95, -4);
	    pts.push_back(pt_3);	    
	    Bezier bez4(pts);	    	    	    	    
	    bez4.draw();       
	    break;
	}
	case 's': {
	    cout<<"B_spline curve"<<endl;
	    B_spline::Points test_points;
	    	    
	    B_spline::Point pt0(-142.06, 111.25);
	    test_points.push_back(pt0);
	    B_spline::Point pt1(-130.0, -80.0);
	    test_points.push_back(pt1);
	    B_spline::Point pt2(-60.53, 107.58);
	    test_points.push_back(pt2);    
	    B_spline::Point pt3(27.75, 186.04);
	    test_points.push_back(pt3);   
	    B_spline::Point pt4(56.56, -27.91);
	    test_points.push_back(pt4);
	    B_spline::Point pt5(125.22, 147.42);
	    test_points.push_back(pt5);
	    B_spline::Point pt6(171.0, 186.04);
	    test_points.push_back(pt6);

	    B_spline bspl(test_points, 3);	    	    	    	    
	    bspl.draw();       
	    break;
	}
	case '1': {
	    cout<<"B_spline curve of degree 1"<<endl;
	    B_spline::Points test_points;
	    
	    B_spline::Point pt0(-100.0, -30.0);
	    test_points.push_back(pt0);
	    B_spline::Point pt1(-60.0, 20.0);
	    test_points.push_back(pt1);
	    B_spline::Point pt2(-30.0, -70.0);
	    test_points.push_back(pt2);
	    B_spline bspl_1(test_points, 1); 
	    bspl_1.draw();
	    break;  
	}
	
	case '3': {
	    cout<<"Bezier curve of degree 3"<<endl;
	    Bezier::Points pts;

	    Bezier:: Point pt_0(20, 40);	    
	    pts.push_back(pt_0);
	    Bezier:: Point pt_1(40, 80);	    
	    pts.push_back(pt_0);

	    Bezier bez4(pts);	    	    	    	    
	    bez4.draw(); 
	    break;  
	}
        default: {
	    cout<<"unknown curve"<<endl;
	}
    }
}




















